# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc赠品(jde0元)活动验证,2262,2262-40,sit,bs
涉及接口:运营后台管理系统登录、活动基本信息获取、活动包含的商品信息和查询商品对应的促销活动等接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from air_case.cmdc_login.多采商城登录.多采商城登录 import CmdcMaiiLogin
import requests
import json

module = "cmdc_commodity_activity"

# 第一步登录后台运营平台获取cmdc_access_token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username8")
password = commonFuc().get_business_data(module, "password8")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步进行促销活动列表获取
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url1")
request_body = commonFuc().get_business_data(module, "payload23")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 获取活动对应的activityBasicId和activityType
activity_basic_id = result["data"]["list"][0]["activityBasicId"]
activity_type = result["data"]["list"][0]["activityType"]

# 第三步获取对应活动包含的商品信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url3")
request_body = commonFuc().get_business_data(module, "payload3", activity_basic_id, activity_type)
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)
# print(result)
for i in result["data"]:
    if i["productType"] == 0:
        # 获取活动主商品companyCode、productCode
        company_code = result["data"][0]["companyCode"]
        product_code = result["data"][0]["productCode"]

        # 获取登录所需账号密码
        username = commonFuc().get_business_data(module, "username7")
        password = commonFuc().get_business_data(module, "password7")
        # 获取登录后Cmdc_access_token
        cmdc_access_token = CmdcMaiiLogin(username, password).get_token()
        headers = commonFuc().get_business_data(module, "json_headers1", cmdc_access_token)

        # 第四步获取商品对应的赠品数据并进行验证
        url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url16")
        request_body = [
            {"buyerCartId": 0, "purchaseQuantity": 1, "productCode": product_code, "companyCode": company_code}]

        """
         场景:商品参与满减活动验证
         用例名称：商品参与满减活动验证
         输出：{"productId":111477}
        """

        # 发送请求
        result = requests.post(url, json=request_body, headers=headers)
        result = json.loads(result.content)
        # 获取赠品数据
        result = {"productId": result["data"][0]["purchaseZeroProductList"][0]["productId"]}
        # print(result)
        # 获取预期结果
        check_dict = commonFuc().get_business_data(module, "checkDict23")
        print(check_dict)
        # 断言实际结果中是否包含预期结果的内容
        commonFuc().check_result(check_dict, result)
