# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc套包批量删除,2264,2264-7,sit,bs
主数据平台:运营后台管理系统Excel导入接口和套包批量删除接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.handle_excel import HandleExcel
import requests
import json
import os
import random
import uuid

module = "cmdc_fresenius_group"

# 第一步登录后台运营平台获取cmdc_access_token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username1")
password = commonFuc().get_business_data(module, "password1")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers2", cmdc_access_token)

# 获取文件
BASE_DIR = os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__)))))
file_path = BASE_DIR + "/data/cmdc_files/套包按条件删除.xlsx"

# 获取套包列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url1")
request_body = commonFuc().get_business_data(module, "payload1")
result = requests.post(url, headers=headers, json=request_body)
result = json.loads(result.content)

# 随机获取套包信息
# 生成随机数用于进行套包选择
group_id_a = random.randint(1, len(result["data"]["list"]) - 3)
# 获取套包信息groupCode、groupName
group_code = result["data"]["list"][group_id_a]["groupCode"]
group_name = result["data"]["list"][group_id_a]["groupName"]

# 将套包信息写入文件中
excel = HandleExcel(file_path, "Sheet1")
excel.write_data(row=2, column=1, value=group_code)
excel.write_data(row=2, column=2, value=group_name)

# 第二步进行套包导入操作
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url21")
request_body = commonFuc().get_business_data(module, "payload21")

# 获取文件
file = open(file_path, "rb")
files = {"file": file}
# 发送请求
result = requests.post(url, files=files, headers=headers, data=request_body)
result = json.loads(result.content)
file.close()

# 第三步进行套包批量删除
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url22")
request_body = {"groupIds": [result["data"]["freseniusGroups"][0]["products"][0]["groupId"]], "type": 1, "remarks": "",
                "groupType": 3}
print(request_body)

"""
 场景:套包批量删除
 用例名称：套包批量删除
 输出：{"success":true,"code":"200","message":"OK"}
"""

# 发送请求
result = requests.post(url, headers=headers, json=request_body)
result = json.loads(result.content)
print(result)

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict21")
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
